#!/bin/sh -e

PATH="/usr/local/sbin:/usr/local/bin:/sbin:/bin:/usr/sbin:/usr/bin"

if [ -e /etc/openvpn/server.conf ]; then
	rm /etc/openvpn/server.conf
fi

# load config file
. /etc/setup-netcfg/user.cfg

if [ $vpn_mode = "disable" ]; then
	exit 0
fi

# network and broadcast address
ip1=`echo $br0_address | awk -F. '{print $1}'`
ip2=`echo $br0_address | awk -F. '{print $2}'`
ip3=`echo $br0_address | awk -F. '{print $3}'`
ip4=`echo $br0_address | awk -F. '{print $4}'`

msk1=`echo $br0_netmask | awk -F. '{print $1}'`
msk2=`echo $br0_netmask | awk -F. '{print $2}'`
msk3=`echo $br0_netmask | awk -F. '{print $3}'`
msk4=`echo $br0_netmask | awk -F. '{print $4}'`

nw1=$ip1

if [ $msk2 -eq 255 ]; then
	nw2=$ip2
else
	nw2=0
fi
if [ $msk3 -eq 255 ]; then
	nw3=$ip3
else
	nw3=0
fi
if [ $msk4 -eq 255 ]; then
	exit 1
else
	nw4=0
fi

br0_network="$nw1.$nw2.$nw3.$nw4"
br0_dhcp_start="$nw1.$nw2.$nw3.128"
br0_dhcp_end="$nw1.$nw2.$nw3.136"

if [ $vpn_mode = "TUN" ]; then
	src_file="/etc/setup-netcfg/conf/vpn_server_tun.conf"
elif [ $vpn_mode = "TAP" ]; then
	src_file="/etc/setup-netcfg/conf/vpn_server_tap.conf"
else
	exit 1
fi

sed -e s/@BR_IPADDR@/$br0_address/ $src_file | \
sed -e s/@BR_MASK@/$br0_netmask/ | \
sed -e s/@BR_NETWORK@/$br0_network/ | \
sed -e s/@BR_DHCP_START@/$br0_dhcp_start/ | \
sed -e s/@BR_DHCP_END@/$br0_dhcp_end/ \
 > /etc/openvpn/server.conf
