#!/bin/sh -e

PATH="/usr/local/sbin:/usr/local/bin:/sbin:/bin:/usr/sbin:/usr/bin"

# $1 : 0:use last config, 1:restore default
use_def=$1

# load config file
. /etc/setup-netcfg/default/default_ap.cfg
. /etc/setup-netcfg/user.cfg


# restore mode : force wifi AP mode
if [ $use_def -eq 1 ]; then
	echo "Setting default WLAN AP"
	use_wifi="1"
	wlan_mode="AP"
	wlan_ssid=$wlan_default_apname
	wlan_psk=$wlan_default_psk
	wlan_proto="RSN"
	wlan_channel="1"
	wlan_hidden="0"
fi

#
# /etc/wpa_supplicant.conf
#
CFG_FILE=/etc/wpa_supplicant.conf

if [ -n "$wlan_proto" ]; then
	if [ $wlan_proto = "WPA2-PSK" ]; then
		wlan_proto="RSN"
	fi
	if [ $wlan_proto = "WPA-PSK" ]; then
		wlan_proto="WPA"
	fi
fi

echo "ctrl_interface=/var/run/wpa_supplicant" >  $CFG_FILE

# disabled wifi case
if [ $use_wifi = "0" ]; then
	exit 0
fi

#
if [ $wlan_mode = "STA" ]; then
	echo "update_config=1" >> $CFG_FILE
fi

if [ -n "$wlan_ssid" ] && [ $wlan_mode = "STA" ]; then
	echo "network={"                 >> $CFG_FILE
	echo "    ssid=\"$wlan_ssid\""   >> $CFG_FILE
	echo "    psk=\"$wlan_psk\""     >> $CFG_FILE
	echo "    proto=$wlan_proto"     >> $CFG_FILE
	echo "    key_mgmt=WPA-PSK"      >> $CFG_FILE
	echo "    pairwise=CCMP TKIP"    >> $CFG_FILE
	echo "    group=CCMP TKIP"       >> $CFG_FILE
	echo "}"                         >> $CFG_FILE
fi


#
# /etc/hostapd.conf
#
wlan_wpa_proto=1
if [ "$wlan_proto" = "RSN" ]; then
	wlan_wpa_proto=2
fi

if [ -n "$wlan_ssid" ] && [ $wlan_mode = "AP" ]; then
	sed -e s/@AP_SSID@/$wlan_ssid/ /etc/setup-netcfg/conf/hostapd.conf | \
	sed -e s/@AP_CHANNEL@/$wlan_channel/ | \
	sed -e s/@AP_PROTO@/$wlan_wpa_proto/ | \
	sed -e s/@AP_PSK@/$wlan_psk/  | \
	sed -e s/@AP_HIDDEN@/$wlan_hidden/  > /etc/hostapd.conf
fi

