/* parameter */
var MAX_CAM_NUM = 4;
var MAX_EASYLN_NUM = 8;
var MAX_PF_NUM = 10;

var last_rdata = [];

/*  cfg params to remember */
var cam1_mac = "";
var cam2_mac = "";
var cam3_mac = "";
var cam4_mac = "";

function read_config() {
	$("#top").fadeIn();

	$.getJSON("cgi/cfg_get.cgi", function(data) {
		var len = data.length;

		for(var i = 0; i < len; i++) {
			var name = data[i].id;
			/* checkbox value */
			if(name == "use_safie" || name == "auto_safie" ||
			   name == "use_wifi" || name == "wlan_hidden" ||
			   name == "use_easyln" || name.match(/^easyln[0-7]+_en$/) ||
			   name.match(/^pf[0-9]+_en$/) || name == "use_dhcp" ||
			   name == "use_rb_ping") {
				var flg = false;
				if(data[i].value == "1") {
					flg = true;
				}
				$("#" + data[i].id).prop("checked", flg);
			} else if(name == "usb_eth") {
				if(data[i].value == "") {
					$("#inet_usb").remove();
				}
			/* params to remember */
			} else if(name == "cam1_mac") {
				cam1_mac = data[i].value;
			} else if(name == "cam2_mac") {
				cam2_mac = data[i].value;
			} else if(name == "cam3_mac") {
				cam3_mac = data[i].value;
			} else if(name == "cam4_mac") {
				cam4_mac = data[i].value;
			/* text */
			} else if(name == "poe0_mac" || name == "poe1_mac" ||
			          name == "cam_info_1" || name == "cam_info_2" ||
			          name == "cam_info_3" || name == "cam_info_4") {
				$("#" + name).text(data[i].value);
			/* radio */
			} else if(name == "rb_cfg") {
			/* input, select value */
				$("input[name='rb_cfg']").val([data[i].value]);
			} else {
				$('#' + data[i].id).val(data[i].value);
			}
		}
		/* update available/disabled form */
		inet_if_select($("#inet_if").val());
		inet_dhcp_select($("#inet_dhcp").val());
		use_safie_checkbox($("#use_safie").prop("checked"));
		use_wifi_checkbox($("#use_wifi").prop("checked"));
		use_easyln_checkbox($("#use_easyln").prop("checked"));
		use_dhcp_checkbox($("#use_dhcp").prop("checked"));
		rbcfg_radio($("input[name='rb_cfg']:checked").val());
		use_rb_ping_checkbox($("#use_rb_ping").prop("checked"));

		$.get("cgi/get_status.cgi", {scan:"0"}, function(data) {
			$("#status_content").empty();
			$("#status_content").append(data);
			$("#sending-view").fadeOut();
		});
	});
}

function save_config() {
	$("#sending-view").fadeIn();

	var use_safie = "0";
	if($("#use_safie").prop("checked")) {
		use_safie = "1"
	}

	var auto_safie = "0";
	if($("#auto_safie").prop("checked")) {
		auto_safie = "1"
	}

	var use_wifi = "0";
	if($("#use_wifi").prop("checked")) {
		use_wifi = "1"
	}

	var wlan_hidden = "0";
	if($("#wlan_hidden").prop("checked")) {
		wlan_hidden = "1"
	}

	var use_easyln = "0";
	if($("#use_easyln").prop("checked")) {
		use_easyln = "1"
	}

	var easyln_en = [];
	for(var i = 0; i < MAX_EASYLN_NUM; i++) {
		var val ="0";
		if($("#easyln" + i + "_en").prop("checked")) {
			val = "1";
		}
		easyln_en.push(val);
	}

	var pf_en = [];
	for(var i = 0; i < MAX_PF_NUM; i++) {
		var val ="0";
		if($("#pf" + i + "_en").prop("checked")) {
			val = "1";
		}
		pf_en.push(val);
	}

	var use_dhcp = "0";
	if($("#use_dhcp").prop("checked")) {
		use_dhcp = "1"
	}

	var use_rb_ping = "0";
	if($("#use_rb_ping").prop("checked")) {
		use_rb_ping = "1"
	}

	var url = "cgi/cfg_set.cgi";
	var jsondata = [
			{ "id":"inet_if",        "value":$("#inet_if").val() },
			{ "id":"inet_dhcp",      "value":$("#inet_dhcp").val() },
			{ "id":"inet_address",   "value":$("#inet_address").val() },
			{ "id":"inet_netmask",   "value":$("#inet_netmask").val() },
			{ "id":"inet_gateway",   "value":$("#inet_gateway").val() },
			{ "id":"inet_dns1",      "value":$("#inet_dns1").val() },
			{ "id":"inet_dns2",      "value":$("#inet_dns2").val() },
			{ "id":"lte_apn",        "value":$("#lte_apn").val() },
			{ "id":"lte_user",       "value":$("#lte_user").val() },
			{ "id":"lte_password",   "value":$("#lte_password").val() },
			{ "id":"lte_auth",       "value":$("#lte_auth").val() },

			{ "id":"use_safie", "value":use_safie},
			{ "id":"auto_safie", "value":auto_safie},
			{ "id":"cam_count", "value":$("#cam_count").val() },
			{ "id":"cam1_user",   "value":$("#cam1_user").val() },
			{ "id":"cam2_user",   "value":$("#cam2_user").val() },
			{ "id":"cam3_user",   "value":$("#cam3_user").val() },
			{ "id":"cam4_user",   "value":$("#cam4_user").val() },
			{ "id":"cam1_passwd",   "value":$("#cam1_passwd").val() },
			{ "id":"cam2_passwd",   "value":$("#cam2_passwd").val() },
			{ "id":"cam3_passwd",   "value":$("#cam3_passwd").val() },
			{ "id":"cam4_passwd",   "value":$("#cam4_passwd").val() },
			{ "id":"cam1_tk",   "value":$("#cam1_tk").val() },
			{ "id":"cam2_tk",   "value":$("#cam2_tk").val() },
			{ "id":"cam3_tk",   "value":$("#cam3_tk").val() },
			{ "id":"cam4_tk",   "value":$("#cam4_tk").val() },
			{ "id":"scr_tk",    "value":$("#scr_tk").val() },
			{ "id":"cam1_mac", "value":cam1_mac },
			{ "id":"cam2_mac", "value":cam2_mac },
			{ "id":"cam3_mac", "value":cam3_mac },
			{ "id":"cam4_mac", "value":cam4_mac },

			{ "id":"use_wifi",     "value":use_wifi},
			{ "id":"wlan_mode",    "value":$("#wlan_mode").val() },
			{ "id":"wlan_ssid",    "value":$("#wlan_ssid").val() },
			{ "id":"wlan_psk",     "value":$("#wlan_psk").val() },
			{ "id":"wlan_proto",   "value":$("#wlan_proto").val() },
			{ "id":"wlan_channel", "value":$("#wlan_channel").val() },
			{ "id":"wlan_hidden",  "value":wlan_hidden },

			{ "id":"use_easyln", "value":use_easyln},
			{ "id":"easyln0_en",   "value":easyln_en[0]},
			{ "id":"easyln0_ip",   "value":$("#easyln0_ip").val() },
			{ "id":"easyln0_port", "value":$("#easyln0_port").val() },
			{ "id":"easyln0_type", "value":$("#easyln0_type").val() },
			{ "id":"easyln0_mapp", "value":$("#easyln0_mapp").val() },
			{ "id":"easyln1_en",   "value":easyln_en[1]},
			{ "id":"easyln1_ip",   "value":$("#easyln1_ip").val() },
			{ "id":"easyln1_port", "value":$("#easyln1_port").val() },
			{ "id":"easyln1_type", "value":$("#easyln1_type").val() },
			{ "id":"easyln1_mapp", "value":$("#easyln1_mapp").val() },
			{ "id":"easyln2_en",   "value":easyln_en[2]},
			{ "id":"easyln2_ip",   "value":$("#easyln2_ip").val() },
			{ "id":"easyln2_port", "value":$("#easyln2_port").val() },
			{ "id":"easyln2_type", "value":$("#easyln2_type").val() },
			{ "id":"easyln2_mapp", "value":$("#easyln2_mapp").val() },
			{ "id":"easyln3_en",   "value":easyln_en[3]},
			{ "id":"easyln3_ip",   "value":$("#easyln3_ip").val() },
			{ "id":"easyln3_port", "value":$("#easyln3_port").val() },
			{ "id":"easyln3_type", "value":$("#easyln3_type").val() },
			{ "id":"easyln3_mapp", "value":$("#easyln3_mapp").val() },
			{ "id":"easyln4_en",   "value":easyln_en[4]},
			{ "id":"easyln4_ip",   "value":$("#easyln4_ip").val() },
			{ "id":"easyln4_port", "value":$("#easyln4_port").val() },
			{ "id":"easyln4_type", "value":$("#easyln4_type").val() },
			{ "id":"easyln4_mapp", "value":$("#easyln4_mapp").val() },
			{ "id":"easyln5_en",   "value":easyln_en[5]},
			{ "id":"easyln5_ip",   "value":$("#easyln5_ip").val() },
			{ "id":"easyln5_port", "value":$("#easyln5_port").val() },
			{ "id":"easyln5_type", "value":$("#easyln5_type").val() },
			{ "id":"easyln5_mapp", "value":$("#easyln5_mapp").val() },
			{ "id":"easyln6_en",   "value":easyln_en[6]},
			{ "id":"easyln6_ip",   "value":$("#easyln6_ip").val() },
			{ "id":"easyln6_port", "value":$("#easyln6_port").val() },
			{ "id":"easyln6_type", "value":$("#easyln6_type").val() },
			{ "id":"easyln6_mapp", "value":$("#easyln6_mapp").val() },
			{ "id":"easyln7_en",   "value":easyln_en[7]},
			{ "id":"easyln7_ip",   "value":$("#easyln7_ip").val() },
			{ "id":"easyln7_port", "value":$("#easyln7_port").val() },
			{ "id":"easyln7_type", "value":$("#easyln7_type").val() },
			{ "id":"easyln7_mapp", "value":$("#easyln7_mapp").val() },

			{ "id":"pf0_en",   "value":pf_en[0]},
			{ "id":"pf0_ip",   "value":$("#pf0_ip").val() },
			{ "id":"pf0_port", "value":$("#pf0_port").val() },
			{ "id":"pf0_type", "value":$("#pf0_type").val() },
			{ "id":"pf0_mapp", "value":$("#pf0_mapp").val() },
			{ "id":"pf1_en",   "value":pf_en[1]},
			{ "id":"pf1_ip",   "value":$("#pf1_ip").val() },
			{ "id":"pf1_port", "value":$("#pf1_port").val() },
			{ "id":"pf1_type", "value":$("#pf1_type").val() },
			{ "id":"pf1_mapp", "value":$("#pf1_mapp").val() },
			{ "id":"pf2_en",   "value":pf_en[2]},
			{ "id":"pf2_ip",   "value":$("#pf2_ip").val() },
			{ "id":"pf2_port", "value":$("#pf2_port").val() },
			{ "id":"pf2_type", "value":$("#pf2_type").val() },
			{ "id":"pf2_mapp", "value":$("#pf2_mapp").val() },
			{ "id":"pf3_en",   "value":pf_en[3]},
			{ "id":"pf3_ip",   "value":$("#pf3_ip").val() },
			{ "id":"pf3_port", "value":$("#pf3_port").val() },
			{ "id":"pf3_type", "value":$("#pf3_type").val() },
			{ "id":"pf3_mapp", "value":$("#pf3_mapp").val() },
			{ "id":"pf4_en",   "value":pf_en[4]},
			{ "id":"pf4_ip",   "value":$("#pf4_ip").val() },
			{ "id":"pf4_port", "value":$("#pf4_port").val() },
			{ "id":"pf4_type", "value":$("#pf4_type").val() },
			{ "id":"pf4_mapp", "value":$("#pf4_mapp").val() },
			{ "id":"pf5_en",   "value":pf_en[5]},
			{ "id":"pf5_ip",   "value":$("#pf5_ip").val() },
			{ "id":"pf5_port", "value":$("#pf5_port").val() },
			{ "id":"pf5_type", "value":$("#pf5_type").val() },
			{ "id":"pf5_mapp", "value":$("#pf5_mapp").val() },
			{ "id":"pf6_en",   "value":pf_en[6]},
			{ "id":"pf6_ip",   "value":$("#pf6_ip").val() },
			{ "id":"pf6_port", "value":$("#pf6_port").val() },
			{ "id":"pf6_type", "value":$("#pf6_type").val() },
			{ "id":"pf6_mapp", "value":$("#pf6_mapp").val() },
			{ "id":"pf7_en",   "value":pf_en[7]},
			{ "id":"pf7_ip",   "value":$("#pf7_ip").val() },
			{ "id":"pf7_port", "value":$("#pf7_port").val() },
			{ "id":"pf7_type", "value":$("#pf7_type").val() },
			{ "id":"pf7_mapp", "value":$("#pf7_mapp").val() },
			{ "id":"pf8_en",   "value":pf_en[8]},
			{ "id":"pf8_ip",   "value":$("#pf8_ip").val() },
			{ "id":"pf8_port", "value":$("#pf8_port").val() },
			{ "id":"pf8_type", "value":$("#pf8_type").val() },
			{ "id":"pf8_mapp", "value":$("#pf8_mapp").val() },
			{ "id":"pf9_en",   "value":pf_en[9]},
			{ "id":"pf9_ip",   "value":$("#pf9_ip").val() },
			{ "id":"pf9_port", "value":$("#pf9_port").val() },
			{ "id":"pf9_type", "value":$("#pf9_type").val() },
			{ "id":"pf9_mapp", "value":$("#pf9_mapp").val() },

			{ "id":"sinp_enb_p2", "value":$("#sinp_enb_p2").val() },
			{ "id":"sinp_lvl_p2", "value":$("#sinp_lvl_p2").val() },
			{ "id":"sinp_sec_p2", "value":$("#sinp_sec_p2").val() },
			{ "id":"sinp_enb_p4", "value":$("#sinp_enb_p4").val() },
			{ "id":"sinp_lvl_p4", "value":$("#sinp_lvl_p4").val() },
			{ "id":"sinp_sec_p4", "value":$("#sinp_sec_p4").val() },
			{ "id":"sinp_addr_1", "value":$("#sinp_addr_1").val() },
			{ "id":"sinp_addr_2", "value":$("#sinp_addr_2").val() },
			{ "id":"sinp_addr_3", "value":$("#sinp_addr_3").val() },
			{ "id":"sinp_myaddr", "value":$("#sinp_myaddr").val() },
			{ "id":"sinp_smtp",   "value":$("#sinp_smtp").val() },
			{ "id":"sinp_user",   "value":$("#sinp_user").val() },
			{ "id":"sinp_passwd", "value":$("#sinp_passwd").val() },

			{ "id":"br0_address", "value":$("#br0_address").val() },
			{ "id":"br0_netmask", "value":$("#br0_netmask").val() },
			{ "id":"use_dhcp", "value":use_dhcp},
			{ "id":"dhcpd_range_start", "value":$("#dhcpd_range_start").val() },
			{ "id":"dhcpd_range_end",   "value":$("#dhcpd_range_end").val() },
			{ "id":"vpn_mode",   "value":$("#vpn_mode").val() },
			{ "id":"ddns_prov",  "value":$("#ddns_prov").val() },
			{ "id":"ddns_domain","value":$("#ddns_domain").val() },
			{ "id":"ddns_user",  "value":$("#ddns_user").val() },
			{ "id":"ddns_passwd","value":$("#ddns_passwd").val() },
			{ "id":"ntp_url",    "value":$("#ntp_url").val() },

			{ "id":"rb_cfg",    "value":$("input[name='rb_cfg']:checked").val() },
			{ "id":"rb_day",    "value":$("#rb_day").val() },
			{ "id":"rb_week",   "value":$("#rb_week").val() },
			{ "id":"rb_hour",   "value":$("#rb_hour").val() },
			{ "id":"rb_minute", "value":$("#rb_minute").val() },

			{ "id":"use_rb_ping", "value":use_rb_ping},
			{ "id":"ping_dest",   "value":$("#ping_dest").val() },
			{ "id":"ping_sec",   "value":$("#ping_sec").val() },
			{ "id":"ping_nfail",  "value":$("#ping_nfail").val() },
			{ "id":"ping_nrboot", "value":$("#ping_nrboot").val() },

			/* next params are not config. just info */
			{ "id":"cam1_ip", "value":$("#cam1_ip").val() },
			{ "id":"cam2_ip", "value":$("#cam2_ip").val() },
			{ "id":"cam3_ip", "value":$("#cam3_ip").val() },
			{ "id":"cam4_ip", "value":$("#cam4_ip").val() },
			{ "id":"new_passwd", "value":$("#new_passwd").val() }
	];

	<!-- clean-up last check results -->
	$("#set_result").empty();
	for(var i = 0; i < last_rdata.length; i++) {
		$("#" + last_rdata[i].result).css("background-color","#fff");
	}

	if($("#inet_if").val() != "LTE" && use_easyln == "1") {
		var info = '<hr><p class="lead alert alert-danger text-center">インターフェース(WAN)でLTEを選択しないとEasyLinkは使用出来ません</p>'
		$("#set_result").append(info);
		$("#sending-view").fadeOut();
		return;
	}

	if(use_wifi == "0" && $("#inet_if").val() == "WLAN") {
		var info = '<hr><p class="lead alert alert-danger text-center">インターフェース(WAN)でWLANを選択した場合、無線LANを有効にする必要があります</p>'
		$("#set_result").append(info);
		$("#sending-view").fadeOut();
		return;
	}
	if(use_wifi == "1" && $("#wlan_mode").val() == "AP" && $("#inet_if").val() == "WLAN") {
		var info = '<hr><p class="lead alert alert-danger text-center">インターフェース(WAN)でWLANを選択した場合、無線LANモードはSTAにする必要があります</p>'
		$("#set_result").append(info);
		$("#sending-view").fadeOut();
		return;
	}
	if(use_wifi == "1" && $("#wlan_mode").val() == "STA" && $("#inet_if").val() != "WLAN") {
		var info = '<hr><p class="lead alert alert-danger text-center">インターフェース(WAN)でWLANを選択しない場合、無線LANモードはAPにする必要があります</p>'
		$("#set_result").append(info);
		$("#sending-view").fadeOut();
		return;
	}

	$.post(url,
        JSON.stringify(jsondata),
        function (rdata) {
			if(rdata[0].result == "ok") {
				console.log("reboot!");
				window.location.href = "reboot.html";
			} else {
				console.log("bad input");
				for(var i = 0; i < rdata.length; i++) {
					$("#" + rdata[i].result).css("background-color","#fbb");
				}
				$("#set_result").empty();
				var err_info = '<hr><p class="lead alert alert-danger text-center">設定に誤りがあります</p>'
				$("#set_result").append(err_info);
			}
			last_rdata = rdata;
        },
        "json"
    );
	$("#sending-view").fadeOut();
	console.log("sent");
}

function assign_cam_ip(n) {
	var cnum = $('#assgin_cam_no_' + n).val();
	var ip = $('#cam_ip_' + n).val();

	$('#cam' + cnum + '_ip').val(ip);
}


function update_upnp_cam_ip() {
	$("#sending-view").fadeIn();
	$.getJSON("cgi/update_cam_ip.cgi", function(data) {
		var len = data.length;

		for(var i = 0; i < len; i++) {
			if(data[i].value !=="") { 
				$('#' + data[i].id).val(data[i].value);
			}
		}
		$("#sending-view").fadeOut();
	});
}

var token_err_mess = "取得できませんでした";

function get_safie_token() {
	var url = "cgi/get_safie_token.cgi";

	$("#sending-view").fadeIn();
	$.get(url, {model:$("#cam_model").val(), sn:$("#cam_sn").val()}, function(data) {
		if(data == "") {
			$("#safie_token").val(token_err_mess);
		} else {
			$("#safie_token").val(data);
		}
		$("#sending-view").fadeOut();
	});
}

function set_safie_token() {
	var id;
	var num = $("#cam_no").val();

	if(num == "SCR1800")
		id = "scr_tk";
	else
		id = "cam" + num + "_tk";

	if($("#safie_token").val() != token_err_mess) {
		$("#" + id).val($("#safie_token").val())
	}
}


function update_easyln() {
	$("#sending-view").fadeIn();
	$.getJSON("cgi/get_easylink_info.cgi", function(data) {
		var len = data.length;

		for(var i = 0; i < 8; i++) {
			easyln_edit(i, true);
		}

		for(var i = 0; i < len; i++) {
			var name = data[i].id;

			if(name.match(/^easyln[0-7]+_en$/)) {
				if(data[i].value == "1") {
					$("#" + data[i].id).prop("checked", true);
				} else {
					$("#" + data[i].id).prop("checked", false);
				}
			} else {
				$('#' + data[i].id).val(data[i].value);
			}
		}

		for(var i = 0; i < 8; i++) {
			easyln_edit(i, false);
		}
		$("#sending-view").fadeOut();
	});
}

function send_test_mail(smtp, user, passwd, myaddr, toaddr)
{
	$.get("cgi/send_test_mail.cgi", {smtp:smtp, user:user, passwd:passwd, myaddr:myaddr, toaddr:toaddr}, function(data) {
		alert("メール送信テスト：" + data);
	});
}

function update_status() {
	$("#sending-view").fadeIn();
	$.get("cgi/get_status.cgi", {scan:"1"}, function(data) {
		$("#status_content").empty();
		$("#status_content").append(data);
		$("#sending-view").fadeOut();
	})
}

function file_upload(id)
{
    var formdata = new FormData($('#' + id).get(0));
	var cgi_url = "cgi/upload_file.cgi"

	$("#sending-view").fadeIn();

	if(id == "cfg_upload") {
		cgi_url = "cgi/cfg_upload.cgi"
	}

    $.ajax({
        url  : cgi_url,
        type : "POST",
        data : formdata,
        cache       : false,
        contentType : false,
        processData : false,
        dataType    : "html"
    })
    .done(function(data, textStatus, jqXHR){
		$("#sending-view").fadeOut();
       	alert(data);
		if(data.match(/成功/) && (id == "pkg_upload" || id == "cfg_upload")) {
			var res = confirm('今すぐ再起動しますか？');
			if(res) {
				reboot_system("normal");
			}
		}
    })
    .fail(function(jqXHR, textStatus, errorThrown){
		$("#sending-view").fadeOut();
        alert("アップロードに失敗しました");
    });
}

function reboot_system(val) {
	var url = "cgi/reboot_system.cgi";

	$.get(url, {option:val}, function(data) {
		console.log(data);
		window.location.href = "reboot.html";
	});
}

function save_cfgfile(val) {
	var now = new Date();
	var year = now.getYear();
	var month = now.getMonth() + 1;
	var day = now.getDate();
	if(year < 2000) { year += 1900; }
	if(month < 10) { month = "0" + month; }
	if(day < 10) { day = "0" + day; }

	var xhr = new XMLHttpRequest();
	xhr.open("GET", "cgi/cfg_download.cgi", true);
	xhr.responseType = "blob";
	xhr.onload = function() {
		var blob = this.response;
		var link = document.createElement('a');
		link.download = "scr" + year + month + day + "cfg.dat";
		link.href = window.URL.createObjectURL(blob);
		link.click();
	};
	xhr.send();
}

function do_ping_test(val) {
	var url = "cgi/test_ping.cgi";

	$.get(url, {addr:val}, function(data) {
		if(data == "ok") {
        	alert("pingに成功しました");
		} else {
        	alert("pingに失敗しました");
		}
	});
}

<!-- active/inactive control -->
function inet_if_select(value) {
	var mode = true;

	if(value == "LTE") {
		mode = false;
	}
	$("#lte_apn").prop("disabled", mode);
	$("#lte_user").prop("disabled", mode);
	$("#lte_password").prop("disabled", mode);
	$("#lte_auth").prop("disabled", mode);
}

function inet_dhcp_select(value) {
	var mode = true;

	if(value == "STATIC") {
		mode = false;
	}
	$("#inet_address").prop("disabled", mode);
	$("#inet_netmask").prop("disabled", mode);
	$("#inet_gateway").prop("disabled", mode);
	$("#inet_dns1").prop("disabled", mode);
	$("#inet_dns2").prop("disabled", mode);
}

function use_safie_checkbox(value) {
	var mode = true;

	if(value) {
		mode = false;
	} else {
		$("#auto_safie").prop("checked", false);
	}
	$("#auto_safie").prop("disabled", mode);
	$("#scr_tk").prop("disabled", mode);
	$("#cam1_tk").prop("disabled", mode);
	$("#cam2_tk").prop("disabled", mode);
	$("#cam3_tk").prop("disabled", mode);
	$("#cam4_tk").prop("disabled", mode);
	$("#cam1_user").prop("disabled", mode);
	$("#cam2_user").prop("disabled", mode);
	$("#cam3_user").prop("disabled", mode);
	$("#cam4_user").prop("disabled", mode);
	$("#cam1_passwd").prop("disabled", mode);
	$("#cam2_passwd").prop("disabled", mode);
	$("#cam3_passwd").prop("disabled", mode);
	$("#cam4_passwd").prop("disabled", mode);

	$("#cam_count").prop("disabled", mode);
	$("#cam_update_ip").prop("disabled", mode);
	$("#cam1_ip").prop("disabled", mode);
	$("#cam2_ip").prop("disabled", mode);
	$("#cam3_ip").prop("disabled", mode);
	$("#cam4_ip").prop("disabled", mode);
	$("#safie_tk_btn").prop("disabled", mode);

	cam_count_select($("#cam_count").val());

	/* sinput select */
	if(value) {
		$("#sinp_safie_p2").removeAttr("disabled");
		$("#sinp_safie_p4").removeAttr("disabled");
	} else {
		$("#sinp_safie_p2").attr("disabled", "disabled");
		$("#sinp_safie_p4").attr("disabled", "disabled");
	}
}

function cam_count_select(value) {
	var mode = true;
	var cnt = MAX_CAM_NUM;

	for(var i = 1; i <= MAX_CAM_NUM; i++) {
		$("#cam" + i + "_tk").prop("disabled", true);
		$("#cam" + i + "_ip").prop("disabled", true);
		$("#cam" + i + "_user").prop("disabled", true);
		$("#cam" + i + "_passwd").prop("disabled", true);
	}

	if($("#use_safie").prop("checked")) {
		mode = false;
		cnt = value;
	}
	
	for(var i = 1; i <= cnt; i++) {
		$("#cam" + i + "_tk").prop("disabled", mode);
		$("#cam" + i + "_ip").prop("disabled", mode);
		$("#cam" + i + "_user").prop("disabled", mode);
		$("#cam" + i + "_passwd").prop("disabled", mode);
	}
}

function use_wifi_checkbox(value) {
	var mode = true;

	if(value) {
		mode = false;
	}
	$("#wlan_mode").prop("disabled", mode);
	$("#wlan_ssid").prop("disabled", mode);
	$("#wlan_psk").prop("disabled", mode);
	$("#wlan_proto").prop("disabled", mode);
	$("#wlan_channel").prop("disabled", mode);
	$("#wlan_hidden").prop("disabled", mode);

	wlan_mode_select($("#wlan_mode").val());
}

function wlan_mode_select(value) {
	var mode = true;

	if($("#use_wifi").prop("checked") && value == "AP") {
		mode = false;
	}
	$("#wlan_channel").prop("disabled", mode);
	$("#wlan_hidden").prop("disabled", mode);
}

function use_easyln_checkbox(value) {
	if(!value) {
		for(var i = 0; i < 8; i++) {
			$("#easyln" + i + "_en").prop("checked", false);
		}
		$("#update_easyln").prop("disabled", true);
	} else {
		$("#update_easyln").prop("disabled", false);
	}
}

function easyln_edit(n, value) {
	var mode = true;

	if(value) {
		mode = false;
	}
	$("#easyln" + n + "_ip").prop("disabled", mode);
	$("#easyln" + n + "_port").prop("disabled", mode);
	$("#easyln" + n + "_type").prop("disabled", mode);
	$("#easyln" + n + "_mapp").prop("disabled", mode);
}

function ddns_prov_select(value) {
	var mode = true;

	if(value != "disable") {
		mode = false;
	}
	$("#ddns_domain").prop("disabled", mode);
	$("#ddns_user").prop("disabled", mode);
	$("#ddns_passwd").prop("disabled", mode);
}

function use_dhcp_checkbox(value) {
	var mode = true;

	if(value) {
		mode = false;
	}
	$("#dhcpd_range_start").prop("disabled", mode);
	$("#dhcpd_range_end").prop("disabled", mode);
}

function update_pw_checkbox(value) {
	if(value) {
		$("#new_passwd").prop("disabled", false);
	} else {
		$("#new_passwd").val("");
		$("#new_passwd").prop("disabled", true);
	}
}

function sinput_select(value, pin) {
	var mode = true;

	if(value == "mail") {
		mode = false;
	}
	$("#sinp_lvl_p" + pin).prop("disabled", mode);
	$("#sinp_sec_p" + pin).prop("disabled", mode);
	$("#sinp_sub_p" + pin).prop("disabled", mode);
	$("#sinp_body_p" + pin).prop("disabled", mode);
}

function rbcfg_radio(value) {
	var mode = true;

	if(value != "disable") {
		mode = false;
	}
	$("#rb_hour").prop("disabled", mode);
	$("#rb_minute").prop("disabled", mode);

	if(value == "month") {
		$("#rb_day").prop("disabled", false);
		$("#rb_week").prop("disabled", true);
	} else if(value == "week") {
		$("#rb_day").prop("disabled", true);
		$("#rb_week").prop("disabled", false);
	} else {
		$("#rb_day").prop("disabled", true);
		$("#rb_week").prop("disabled", true);
	}
}

function use_rb_ping_checkbox(value) {
	var mode = true;

	if(value) {
		mode = false;
	}
	$("#ping_dest").prop("disabled", mode);
	$("#ping_sec").prop("disabled", mode);
	$("#ping_nfail").prop("disabled", mode);
	$("#ping_nrboot").prop("disabled", mode);
}

